% Models of Marine Vessels.
% Guidance, Navigation and Control Toolbox. 
% Version 1.6 (R13) 24th-Mar-2003
%
% Author: Thor I. Fossen
%
% Standard ship, semi-submersible and underwater vehicle models.
%
%    Ships:
%    mariner     - Mariner class vessel, L=160 m (nonlinear maneuvering model).
%    tanker      - Esso Osaka tanker, L=304 m (nonlinear course unstable maneuvering model).
%    container   - Container ship, L=175 m (nonlinear maneuvering model including the roll mode)
%    Lcontainer  - Container ship, L=175 m (LINEAR maneuvering model including the roll mode)
%
%    Underwater vehicles:
%    dsrv        - Deep submergence rescue vehicle (DSRV), L = 5.0 m
%    npsauv      - Naval Postgraduate School autnomous underwater vehicle (AUV), L = 5.3 m
%
%    See also simdemo.m
%
% Copyright (c) 2001 by Marine Cybernetics <http://www.marinecybernetics.com/>
